-----------------------------------------------------------------------------------------------
-- Client Lua Script for $safeprojectname$
-- Author      : $username$
-- Create Date : $time$
-----------------------------------------------------------------------------------------------

require "Window"


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ Module Definition
-----------------------------------------------------------------------------------------------
local $safeprojectname$ = {}

-----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------

local function DeepCopy(o)
	if type(o) ~= 'table' then return o end

	local copy = {}
	for k,v in next, o do copy[k] = DeepCopy(v) end
	return copy
end

local function PostChat(s)
	ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, s)
end


-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------

function $safeprojectname$:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self

	-- add class variable initializations here

	o.settings = {				-- default settings for saved settings
		isVisible = true,
	}

	return o
end

function $safeprojectname$:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = { }
	Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ OnLoad
-----------------------------------------------------------------------------------------------

function $safeprojectname$:OnLoad()
	self.onXmlDocLoadedCalled = false

	-- create form
	self.xmlDoc = XmlDoc.CreateFromFile("$safeprojectname$.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)

	-- add menu interface list button 
	Apollo.RegisterEventHandler("$safeprojectname$_ShowMenu", "OnShowMenu", self)
	Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)

	-- add a slash commands
	--Apollo.RegisterSlashCommand("replaceWithShortSlashCommandHere", "OnCommand", self)
	Apollo.RegisterSlashCommand("$safeprojectname$", "OnCommand", self)
end

function $safeprojectname$:OnInterfaceMenuListHasLoaded()
	-- call the user menu list addon and add a button for this addon
	Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "$safeprojectname$",
		{ "$safeprojectname$_ShowMenu", "", "IconSprites:Icon_Windows_UI_CRB_Checkmark" })
end


-----------------------------------------------------------------------------------------------
-- StatMeter OnDocLoaded
-----------------------------------------------------------------------------------------------

function $safeprojectname$:OnDocLoaded()
	if self.xmlDoc == nil or not self.xmlDoc:IsLoaded() then
		return
	end

	-- Load the window

	self.wndMain = Apollo.LoadForm(self.xmlDoc, "$safeprojectname$", nil, self)
	if not self.wndMain then
		Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
		return
	end

	-- solve classic wild star async form load "problem" by letting either/both doc load, or
	--  settings load, initialize windows and app through the InitializeWindows function. 
	self.onXmlDocLoadedCalled = true
	self:InitializeWindows()
end


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ Functions
-----------------------------------------------------------------------------------------------

-- called to update the addon. this is the addon's main update function
function $safeprojectname$:OnFrame()
	local settings, wndMain = self.settings, self.wndMain

	if not wndMain or not settings.isVisible then
		return
	end

end


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ Form Functions
-----------------------------------------------------------------------------------------------

function $safeprojectname$:OnShow()
end


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ Startup
-----------------------------------------------------------------------------------------------

function $safeprojectname$:OnSave(eType)
	local tSave

	if eType == GameLib.CodeEnumAddonSaveLevel.Character then
		local settings = self.settings

		tSave = { }

		for k,v in pairs(settings) do
			tSave[k] = DeepCopy(v)
		end
	end

	return tSave
end

function $safeprojectname$:OnRestore(eType, tSave)
	if eType == GameLib.CodeEnumAddonSaveLevel.Character then
		if tSave then
			local settings = self.settings

			for k,v in pairs(tSave) do
				settings[k] = DeepCopy(v)
			end
		end

		self:InitializeWindows()
	end
end

-- the real addon startup function, which can be called on doc load, or settings
--  load, in either order. will get called twice if there are saved settings.
function $safeprojectname$:InitializeWindows()
	local settings,wndMain = self.settings, self.wndMain

	-- some non-window dependant initialization

	-- the rest needs docload
	if not self.onXmlDocLoadedCalled then
		return
	end

	wndMain:Show(settings.isVisible)
end


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ Commands
-----------------------------------------------------------------------------------------------

function $safeprojectname$:OnShowMenu()					-- used by the InterfaceMenuList button
	self:OnCommand(nil)
end

function $safeprojectname$:OnCommand(sCommand, sArgs)
	local settings,wndMain = self.settings, self.wndMain

	if not sArgs or sArgs == "" then					-- toggle display window
		settings.isVisible = not settings.isVisible		-- toggle value
		wndMain:Show(settings.isVisible)				-- show the window

	elseif sArgs == "help" then
		PostChat("$safeprojectname$ commands:")
		PostChat(" /$safeprojectname$ - show the display")
		PostChat(" /$safeprojectname$ help - this help message")
	end
end


-----------------------------------------------------------------------------------------------
-- $safeprojectname$ Instance
-----------------------------------------------------------------------------------------------

local $safeprojectname$Inst = $safeprojectname$:new()
$safeprojectname$Inst:Init()

